> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# List payment runs

GET https://rest.test.zuora.com/v1/payment-runs

Retrieves the information about all payment runs. You can define filterable fields to restrict the data returned in the response.

### Filtering

You can use query parameters to restrict the data returned in the response. Each query parameter corresponds to one field in the response body.

If the value of a filterable field is string, you can set the corresponding query parameter to `null` when filtering. Then, you can get the response data with this field value being `null`. 

Examples:

- /v1/payment-runs?status=Processed

- /v1/payment-runs?targetDate=2017-10-10&status=Pending

- /v1/payment-runs?status=Completed&sort=+updatedDate


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/payments/payment-runs/get-payment-runs

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Query parameters

- `page` (integer, optional, default: 1) — The index number of the page that you want to retrieve. This parameter is dependent on `pageSize`. You must set `pageSize` before specifying `page`. For example, if you set `pageSize` to `20` and `page` to `2`, the 21st to 40th records are returned in the response.
- `pageSize` (integer, optional, default: 20) — The number of records returned per page in the response.
- `createdById` (string, optional) — This parameter filters the response based on the `createdById` field.
- `createdDate` (datetime, optional) — This parameter filters the response based on the `createdDate` field.
- `status` (enum, optional) — This parameter filters the response based on the `status` field.
  - Allowed values: `Pending`, `Processing`, `Completed`, `Error`, `Canceled`
- `targetDate` (date, optional) — This parameter filters the response based on the `targetDate` field.
- `updatedById` (string, optional) — This parameter filters the response based on the `updatedById` field.
- `updatedDate` (datetime, optional) — This parameter filters the response based on the `updatedDate` field.
- `sort` (string, optional) — This parameter restricts the order of the data returned in the response. You can use this parameter to supply a dimension you want to sort on. A sortable field uses the following form: *operator* *field_name* You can use at most two sortable fields in one URL path. Use a comma to separate sortable fields. For example: *operator* *field_name*, *operator* *field_name* *operator* is used to mark the order of sequencing. The operator is optional. If you only specify the sortable field without any operator, the response data is sorted in descending order by this field. - The `-` operator indicates an ascending order. - The `+` operator indicates a descending order. By default, the response data is displayed in descending order by payment run number. *field_name* indicates the name of a sortable field. The supported sortable fields of this operation are as below: - targetDate - status - createdDate - createdById - updatedDate - updatedById Examples: - /v1/payment-runs?sort=+createdDate - /v1/payment-runs?status=Processing&sort=-createdById,+targetDate

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

## Response

### 200

OK

- `nextPage` (string, optional) — The URL for requesting the next page of the response, if it exists; otherwise absent.
- `paymentRuns` (list of GETPaymentRunType, optional) — Container for payment runs.
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.

## Types

### GETPaymentRunType

- `accountId` (string, optional) — The ID of the customer account associated with the payment run.
- `applyCreditBalance` (boolean, optional) — **Note:** This field is only available if you have the Credit Balance feature enabled and the Invoice Settlement feature disabled. Whether to apply credit balances in the payment run. This field is only available when you have Invoice Settlement feature disabled.
- `autoApplyCreditMemo` (boolean, optional) — **Note:** This field is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. Whether to automatically apply a posted credit memo to one or more receivables in the payment run.
- `autoApplyUnappliedPayment` (boolean, optional) — **Note:** This field is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. Whether to automatically apply unapplied payments to one or more receivables in the payment run.
- `batch` (string, optional) — The alias name given to a batch.
- `billCycleDay` (string, optional) — The billing cycle day (BCD), the day of the month when a bill run generates invoices for the account.
- `billingRunId` (string, optional) — The ID of the bill run.
- `collectPayment` (boolean, optional) — Whether to process electronic payments during the execution of payment runs.
- `completedOn` (string, optional, nullable) — The date and time when the payment run is completed, in `yyyy-mm-dd hh:mm:ss` format. For example, 2017-03-01 11:39:58.
- `consolidatedPayment` (boolean, optional) — **Note:** The **Process Electronic Payment** permission also needs to be allowed for a Manage Payment Runs role to work. See [Payments Roles](https://knowledgecenter.zuora.com/CF_Users_and_Administrators/A_Administrator_Settings/User_Roles/e_Payments_Roles) for more information. Whether to process a single payment for all receivables that are due on an account.
- `createdById` (string, optional) — The ID of the Zuora user who created the payment run.
- `createdDate` (string, optional) — The date and time when the payment run was created, in `yyyy-mm-dd hh:mm:ss` format. For example, 2017-03-01 15:31:10.
- `currency` (string, optional) — A currency defined in the web-based UI administrative settings.
- `executedOn` (string, optional, nullable) — The date and time when the payment run is executed, in `yyyy-mm-dd hh:mm:ss` format. For example, 2017-03-01 11:30:37.
- `id` (string, optional) — The ID of the payment run.
- `number` (string, optional) — The identification number of the payment run.
- `organizationLabels` (list of GetPaymentRunTypeOrganizationLabelsItems, optional) — The organization(s) that the object belongs to. Note: This field is available only when the Multi-Org feature is enabled.
- `paymentGatewayId` (string, optional, nullable) — The ID of the gateway instance that processes the payment.
- `processPaymentWithClosedPM` (boolean, optional) — **Note:** The **Process Electronic Payment** permission also needs to be allowed for a Manage Payment Runs role to work. See [Payments Roles](https://knowledgecenter.zuora.com/CF_Users_and_Administrators/A_Administrator_Settings/User_Roles/e_Payments_Roles) for more information. Whether to process payments even if the default payment method is closed.
- `runDate` (string, optional) — The date and time when the scheduled payment run is to be executed for collecting payments.
- `status` (enum, optional) — The status of the created payment run.
  - Allowed values: `Pending`, `Processing`, `Completed`, `Error`, `Canceled`
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.
- `targetDate` (date, optional) — The target date used to determine which receivables to be collected in the payment run.
- `updatedById` (string, optional) — The ID of the Zuora user who last updated the payment run.
- `updatedDate` (string, optional) — The date and time when the payment run was last updated, in `yyyy-mm-dd hh:mm:ss` format. For example, 2017-03-02 15:36:10.
- `useCustomPaymentMethods` (boolean, optional) — Whether to enable payment profiles for a payment run.

### GetPaymentRunTypeOrganizationLabelsItems

- `organizationId` (string, optional) — The organization ID.
- `organizationName` (string, optional) — The organization name.

## Examples

**Response**

```json
{
  "nextPage": "/payment-runs?page=2",
  "paymentRuns": [
    {
      "applyCreditBalance": false,
      "collectPayment": true,
      "completedOn": "2017-12-28 13:00:00",
      "consolidatedPayment": false,
      "createdById": "2c92c0f956bc8fcb0156f8eee04b4d54",
      "createdDate": "2017-12-27 13:00:00",
      "executedOn": "2017-12-28 13:00:00",
      "id": "2c92c0856078bbcb016096576ccb75ca",
      "number": "PR-00002121",
      "processPaymentWithClosedPM": false,
      "status": "Completed",
      "targetDate": "2017-12-28",
      "updatedById": "2c92c0f956bc8fcb0156f8eee04b4d54",
      "updatedDate": "2017-12-28 13:00:00"
    }
  ],
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/payment-runs"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/payment-runs';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/payment-runs"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/payment-runs")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/v1/payment-runs")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/v1/payment-runs', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/payment-runs");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/payment-runs")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```